
/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.remote;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;

import net.micode.notes.R;
import net.micode.notes.ui.NotesListActivity;
import net.micode.notes.ui.NotesPreferenceActivity;


public class GTaskASyncTask extends AsyncTask<Void, String, Integer> {

    private static int GTASK_SYNC_NOTIFICATION_ID = 5234235;

    public interface OnCompleteListener {
        void onComplete();
    }

    private Context mContext; // 上下文对象

    private NotificationManager mNotifiManager; // 通知管理器对象

    private GTaskManager mTaskManager; // GTask 管理器对象

    private OnCompleteListener mOnCompleteListener; // 异步任务完成后的回调接口

    public GTaskASyncTask(Context context, OnCompleteListener listener) {
        mContext = context; // 初始化上下文对象
        mOnCompleteListener = listener; // 初始化回调接口
        mNotifiManager = (NotificationManager) mContext
                .getSystemService(Context.NOTIFICATION_SERVICE); // 初始化通知管理器对象
        mTaskManager = GTaskManager.getInstance(); // 获取 GTask 管理器对象的单例
    }

    public void cancelSync() {
        mTaskManager.cancelSync(); // 取消 GTask 同步
    }

    public void publishProgess(String message) {
        publishProgress(new String[] {
                message
        }); // 向主线程发布进度更新
    }

    private void showNotification(int tickerId, String content) {
        Notification notification = new Notification(R.drawable.notification, mContext
                .getString(tickerId), System.currentTimeMillis()); // 创建通知
        notification.defaults = Notification.DEFAULT_LIGHTS; // 设置默认的通知灯光
        notification.flags = Notification.FLAG_AUTO_CANCEL; // 设置通知被点击后自动取消
        PendingIntent pendingIntent;
        if (tickerId != R.string.ticker_success) { // 如果是同步失败的通知
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext,
                    NotesPreferenceActivity.class), 0); // 点击通知后打开 NotesPreferenceActivity

        } else { // 如果是同步成功的通知
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext,
                    NotesListActivity.class), 0); // 点击通知后打开 NotesListActivity
        }
        //notification.setLatestEventInfo(mContext, mContext.getString(R.string.app_name), content,
        // pendingIntent); // 设置通知的标题、内容和点击后的操作
        mNotifiManager.notify(GTASK_SYNC_NOTIFICATION_ID, notification); // 发送通知
    }

    @Override
    protected Integer doInBackground(Void... unused) {
        publishProgess(mContext.getString(R.string.sync_progress_login, NotesPreferenceActivity
                .getSyncAccountName(mContext))); // 向主线程发布进度更新，显示正在登录的提示信息
        return mTaskManager.sync(mContext, this); // 开始 GTask 同步，并返回同步结果
    }

    @Override
    protected void onProgressUpdate(String... progress) {
        showNotification(R.string.ticker_syncing, progress[0]); // 显示同步进度的通知
        if (mContext instanceof GTaskSyncService) {
            ((GTaskSyncService) mContext).sendBroadcast(progress[0]); // 向 GTaskSyncService 发送广播，以便更新 UI
        }
    }

    @Override
    protected void onPostExecute(Integer result) {
        if (result == GTaskManager.STATE_SUCCESS) { // 如果同步成功
            showNotification(R.string.ticker_success, mContext.getString(
                    R.string.success_sync_account, mTaskManager.getSyncAccount())); // 显示同步成功的通知
            NotesPreferenceActivity.setLastSyncTime(mContext, System.currentTimeMillis()); // 更新最后同步时间
        } else if (result == GTaskManager.STATE_NETWORK_ERROR) { // 如果网络错误
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_network)); // 显示同步失败的通知，提示网络错误
        } else if (result == GTaskManager.STATE_INTERNAL_ERROR) { // 如果内部错误
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_internal)); // 显示同步失败的通知，提示内部错误
        } else if (result == GTaskManager.STATE_SYNC_CANCELLED) { // 如果同步被取消
            showNotification(R.string.ticker_cancel, mContext
                    .getString(R.string.error_sync_cancelled)); // 显示同步被取消的通知
        }
        if (mOnCompleteListener != null) { // 如果设置了 OnCompleteListener
            new Thread(new Runnable() { // 在新线程中执行 OnCompleteListener

                public void run() {
                    mOnCompleteListener.onComplete();
                }
            }).start();
        }
    }
}